package com.css.simulation.resource.scheduler.common.configuration.kubernetes;

import com.css.simulation.resource.scheduler.service.domain.KubernetesNodeTO;
import io.kubernetes.client.openapi.ApiClient;
import io.kubernetes.client.util.ClientBuilder;
import io.kubernetes.client.util.KubeConfig;
import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.List;

@Configuration
@ConfigurationProperties(prefix = "kubernetes")
@Data
public class KubernetesConfiguration {

    private String namespace;
    private String podTimeout;
    private String imageVtdGpu;
    private String commandVtdGpu;
    private String commandVtdCarsimGpu;
    private String imageVtdNogpu;
    private String commandVtdNogpu;
    private String commandVtdCarsimNogpu;
    private String carsimImage;
    private String carsimCommand;
    private List<KubernetesNodeTO> nodeList;

    @Bean
    public ApiClient apiClient() throws IOException {
//        File config = ResourceUtils.getFile("classpath:kubernetes/config");  // 开发环境可用，生产环境不行，无法从jar 包读取
//        File config = new File("D:\\idea-project\\simulation-cloud\\simulation-resource-scheduler\\src\\main\\resources\\kubernetes\\config");  //windows
        File config = new File("/root/.kube/config");   //linux
//
//        ClassPathResource classPathResource = new ClassPathResource("kubernetes/config");
//        InputStream inputStream = classPathResource.getInputStream();
//        FileUtil.writeInputStreamToLocalFile();
        FileReader fileReader = new FileReader(config);
        return ClientBuilder.kubeconfig(KubeConfig.loadKubeConfig(fileReader)).build();
    }

}
