package com.css.simulation.resource.scheduler.dao.entity;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class VehiclePO {

    /**
     * 车辆模型
     * 		"model": {
     * 			"model_label": "AudiA6_10"
     *                },
     "dynamics": {
     "dynamics_maxspeed": 67,
     "dynamics_enginepower": 150000,
     "dynamics_maxdecel": 9.5,
     "dynamics_maxsteering": 0.48,
     "dynamics_mass": 1700,
     "dynamics_frontsurfaceeffective": 2.2,
     "dynamics_airdragcoefficient": 0.31,
     "dynamics_rollingresistance": 0,
     "dynamics_wheeldiameter": 0.684,
     "dynamics_wheeldrive": "wheel_drive_front",
     "dynamics_overallefficiency": 0.75,
     "dynamics_distfront": 3.838,
     "dynamics_distrear": 1.086,
     "dynamics_distleft": 0.94,
     "dynamics_distright": 0.94,
     "dynamics_distheight": 1.444,
     "dynamics_wheelbase": 2.91
     },
     */
    private String modelLabel;
    private BigDecimal maxSpeed;
    private BigDecimal enginePower;
    private BigDecimal maxDeceleration;
    private BigDecimal maxSteeringAngle;
    private BigDecimal mass;
    private BigDecimal frontSurfaceEffective;
    private BigDecimal airDragCoefficient;
    private BigDecimal rollingResistanceCoefficient;
    private BigDecimal wheelDiameter;
    private String wheelDrive;
    private BigDecimal overallEfficiency;
    private BigDecimal frontDistance;
    private BigDecimal rearDistance;
    private BigDecimal leftDistance;
    private BigDecimal rightDistance;
    private BigDecimal heightDistance;
    private BigDecimal wheelbase;
}
