package com.css.simulation.resource.scheduler.dao.mapper;


import com.css.simulation.resource.scheduler.dao.entity.ProjectPO;
import org.apache.ibatis.annotations.*;
import org.apache.ibatis.type.JdbcType;

import java.sql.Timestamp;
import java.util.List;

@Mapper
public interface ManualProjectMapper {


    @Results(id = "project", value = {
            @Result(column = "id", property = "id", jdbcType = JdbcType.VARCHAR),
            @Result(column = "scene", property = "scenePackageId", jdbcType = JdbcType.VARCHAR),
            @Result(column = "create_user_id", property = "createUserId", jdbcType = JdbcType.VARCHAR),
            @Result(column = "parallelism", property = "parallelism", jdbcType = JdbcType.VARCHAR),
            @Result(column = "project_type", property = "projectType", jdbcType = JdbcType.VARCHAR),
            @Result(column = "is_choice_gpu", property = "isChoiceGpu", jdbcType = JdbcType.VARCHAR),
            @Result(column = "max_simulation_time", property = "maxSimulationTime", jdbcType = JdbcType.VARCHAR)
    })
    @Select("select id,\n" +
            "       scene,\n" +
            "       create_user_id,\n" +
            "       is_choice_gpu,\n" +
            "       '1' project_type,\n" +
            "       max_simulation_time\n" +
            "from simulation_manual_project\n" +
            "where id = #{projectId}")
    ProjectPO selectById(@Param("projectId") String projectId);


    @Select("select is_choice_gpu\n" +
            "from simulation_manual_project\n" +
            "where id = #{projectId}")
    String selectIsChoiceGpuById(@Param("projectId") String projectId);

    @ResultMap("project")
    @Select("select id, scene, create_user_id, parallelism, '1' project_type\n" +
            "from simulation_manual_project\n" +
            "where is_deleted = '0'\n" +
            "  and now_run_state = #{nowRunState}")
    List<ProjectPO> selectByNowRunState(@Param("nowRunState") String nowRunState);


    @Update("update simulation_manual_project\n" +
            "set now_run_state  = #{state},\n" +
            "    finish_time = #{finishTime}\n" +
            "where id = #{id}")
    void updateProjectState(@Param("id") String id, @Param("state") String state, @Param("finishTime") Timestamp finishTime);


    @Select("select create_user_id\n" +
            "from simulation_manual_project\n" +
            "where id = #{id}")
    String selectCreateUserById(@Param("id") String id);
}
